' This is a Buffer class incorperating the TCP transport protocol from system.net
' This is also a full wrapper class for the TCPListner and TCPClient Classes...

Imports System.Net
Imports System.Text

Public Class TCPSocket
    Public Enum TCP_State
        Listen
        Conect
        Client
    End Enum
    Private Structure Raw_Data_Type
        Dim Data() As Byte
    End Structure


    Private TCP_Listen As Sockets.TcpListener
    Private TCP_Client As Sockets.TcpClient
    Private WithEvents C_Timer As System.Windows.Forms.Timer
    Private WithEvents I_Timer As System.Windows.Forms.Timer
    Private B_Data() As String
    Private B_Sender() As IPAddress
    Private RecievedBytes() As Byte
    Private RemoteIpEndPoint As New IPEndPoint(IPAddress.IPv6Any, 0)
    Private Tot_Array As Integer
    Private Tmp_loop_1 As Integer
    Private Con_Method As TCP_State
    Private Con_Proc As Boolean
    Private Raw_Data() As Raw_Data_Type
    Public Event Data_Arrival(ByVal Data As String, ByVal Source As IPAddress)
    Public Event Connection_Request(ByVal Remote_IP As EndPoint)
    Public Event Connection_Complete(ByVal Remote_IP As EndPoint)
    Public Event Socket_Error(ByVal Err As Exception)
    Public Event Connection_Error()

    Public Sub New()
        C_Timer = New System.Windows.Forms.Timer
        I_Timer = New System.Windows.Forms.Timer
        C_Timer.Interval = 100
        I_Timer.Interval = 1000
        ReDim B_Data(0)
        ReDim B_Sender(0)
        ReDim Raw_Data(0)
        Con_Proc = False
    End Sub

    Public Function Init(ByVal Method As TCP_State, ByVal Port As Integer) As Boolean
        Try
            Con_Method = Method
            Select Case Con_Method
                Case TCP_State.Client
                    TCP_Client = New Sockets.TcpClient
                Case TCP_State.Listen
                    TCP_Listen = New Sockets.TcpListener(L_IP, Port)
                    TCP_Listen.Start()
                Case Else
                    Exit Function
            End Select
            C_Timer.Enabled = True
            Init = True
        Catch ex As Exception
            Init = False
            RaiseEvent Socket_Error(ex)
        End Try
    End Function

    ' Multiple Definitions of Connect to allow any combination of Attributes.. 
    Public Function Connect(ByVal HostAddress As IPAddress, ByVal Port As Integer) As Boolean
        Select Case Con_Method
            Case TCP_State.Client
                Try
                    TCP_Client.Connect(HostAddress, Port)
                    Return True
                Catch ex As Exception
                    RaiseEvent Socket_Error(ex)
                    Return False
                End Try
            Case Else
                Return False
        End Select
    End Function

    Public Function Connect(ByVal HostName As String, ByVal Port As Integer) As Boolean
        Select Case Con_Method
            Case TCP_State.Client
                Try
                    TCP_Client.Connect(HostName, Port)
                    Return True
                Catch ex As Exception
                    RaiseEvent Socket_Error(ex)
                    Return False
                End Try
            Case Else
                Return False
        End Select
    End Function

    Public Function Connect(ByVal HostEndPoint As IPEndPoint) As Boolean
        Select Case Con_Method
            Case TCP_State.Client
                Try
                    TCP_Client.Connect(HostEndPoint)
                    Return True
                Catch ex As Exception
                    RaiseEvent Socket_Error(ex)
                    Return False
                End Try
            Case Else
                Return False
        End Select
    End Function

    Public Function Close() As Boolean
        Try
            Select Case Con_Method
                Case TCP_State.Client
                    TCP_Client.Close()
                    TCP_Client = Nothing
                Case TCP_State.Listen
                    TCP_Listen.Stop()
                    TCP_Listen = Nothing
            End Select
            C_Timer.Enabled = False
            Close = True
        Catch ex As Exception
            Close = False
        End Try
    End Function

    Public Function Send(ByVal Data As String) As Boolean
        Try
            Select Case Con_Method
                Case TCP_State.Client, TCP_State.Conect
                    TCP_Client.GetStream.Write(Encoding.ASCII.GetBytes(Data), 0, Encoding.ASCII.GetByteCount(Data))
                Case Else
                    Send = False
            End Select
        Catch ex As Exception
            Send = False
            RaiseEvent Socket_Error(ex)
        End Try
    End Function

    Public Function Send(ByVal Byte_ary() As Byte) As Boolean
        Try
            Select Case Con_Method
                Case TCP_State.Client, TCP_State.Conect
                    'TCP_Client.GetStream.Write(Encoding.ASCII.GetBytes(Data), 0, Encoding.ASCII.GetByteCount(Data))
                    TCP_Client.GetStream.Write(Byte_ary, 0, Byte_ary.GetUpperBound(0) + 1)
                Case Else
                    Send = False
            End Select
        Catch ex As Exception
            Send = False
            RaiseEvent Socket_Error(ex)
        End Try
    End Function

    Friend ReadOnly Property State() As Boolean
        Get
            Return Con_Proc
        End Get
    End Property

    Friend ReadOnly Property Status() As TCP_State
        Get
            Return Con_Method
        End Get
    End Property

    Friend ReadOnly Property Loc_Port() As Integer
        Get
            Select Case Con_Method
                Case TCP_State.Listen
                    Return CType(TCP_Listen.LocalEndpoint, IPEndPoint).Port
                Case TCP_State.Client, TCP_State.Conect
                    Return CType(TCP_Client.Client.LocalEndPoint, IPEndPoint).Port
            End Select
        End Get
    End Property

    Friend ReadOnly Property Rem_Port() As Integer
        Get
            Select Case Con_Method
                Case TCP_State.Listen
                    Return -1
                Case TCP_State.Client, TCP_State.Conect
                    Return CType(TCP_Client.Client.RemoteEndPoint, IPEndPoint).Port
            End Select
        End Get
    End Property

    Private Sub C_Timer_Elapsed(ByVal sender As Object, ByVal e As System.EventArgs) Handles C_Timer.Tick
        Select Case Con_Method
            Case TCP_State.Listen
                If TCP_Listen.Pending Then
                    TCP_Client = TCP_Listen.AcceptTcpClient
                    RaiseEvent Connection_Request(TCP_Client.Client.RemoteEndPoint)
                    Con_Method = TCP_State.Conect
                    Con_Proc = True
                    ' Close listening port... We've got our conection
                    TCP_Listen.Stop()
                    TCP_Listen = Nothing
                End If
            Case TCP_State.Client, TCP_State.Conect
                If Con_Proc Then
                    If TCP_Client.Available > 0 Then
                        Try
                            ReDim RecievedBytes(TCP_Client.Available - 1)
                            TCP_Client.GetStream.Read(RecievedBytes, 0, TCP_Client.Available)
                            Tot_Array = UBound(B_Data) + 1
                            ReDim Preserve B_Data(Tot_Array)
                            ReDim Preserve B_Sender(Tot_Array)
                            ReDim Preserve Raw_Data(Tot_Array)
                            B_Data(Tot_Array) = Encoding.ASCII.GetString(RecievedBytes)
                            B_Sender(Tot_Array) = RemoteIpEndPoint.Address
                            Raw_Data(Tot_Array).Data = RecievedBytes
                            I_Timer.Enabled = True
                        Catch ex As Exception
                            RaiseEvent Socket_Error(ex)
                        End Try
                    End If
                    If Not TCP_Client.Connected Then
                        RaiseEvent Connection_Error()
                    End If
                Else
                    If TCP_Client.Connected Then
                        RaiseEvent Connection_Complete(TCP_Client.Client.RemoteEndPoint)
                        Con_Proc = True
                    End If
                End If
        End Select
    End Sub

    Private Sub I_Timer_Elapsed(ByVal sender As Object, ByVal e As System.EventArgs) Handles I_Timer.Tick
        Tot_Array = UBound(B_Data)
        If Tot_Array > 0 Then
            For Tmp_loop_1 = 0 To Tot_Array - 1
                B_Data(Tmp_loop_1) = B_Data(Tmp_loop_1 + 1)
                B_Sender(Tmp_loop_1) = B_Sender(Tmp_loop_1 + 1)
                Raw_Data(Tmp_loop_1) = Raw_Data(Tmp_loop_1 + 1)
            Next
            ReDim Preserve B_Data(Tot_Array - 1)
            ReDim Preserve B_Sender(Tot_Array - 1)
            If B_Data(0) <> "" Then
                RaiseEvent Data_Arrival(B_Data(0), B_Sender(0))
            End If
        Else
            I_Timer.Enabled = False
        End If
    End Sub

    Public Sub Get_Raw(ByRef Data() As Byte)
        Data = Raw_Data(0).Data
    End Sub

    Protected Overrides Sub Finalize()
        Try
            Select Case Con_Method
                Case TCP_State.Client, TCP_State.Conect
                    TCP_Client.Close()
                    TCP_Client = Nothing
                Case TCP_State.Listen
                    TCP_Listen.Stop()
                    TCP_Listen = Nothing
            End Select
        Catch ex As Exception
            'Socket already closed or never initiated..
            'since we closing we can ignore this error..
        End Try
        C_Timer = Nothing
        I_Timer = Nothing
        MyBase.Finalize()
    End Sub

End Class
